import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, HostBinding, NgModule } from '@angular/core';
import * as i1 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';

class MessageComponent {
    constructor(
    // Element reference
    elRef) {
        this.elRef = elRef;
        // Dismiss
        this.selfDismissed = false;
    }
    // Init
    ngOnInit() { MessageComponent.instancesByElement.set(this.elRef.nativeElement, this); }
    dismiss() {
        if (this.message)
            this.message.dismissed = true;
        else
            this.selfDismissed = true;
    }
    // Host classes
    getType() { return this.message ? this.message.type : this.type; }
    get a() { return this.getType() === 'info'; }
    get b() { return this.getType() === 'warning'; }
    get c() { return this.getType() === 'error'; }
    get d() { return this.getType() === 'unavailable'; }
    get e() { return this.message?.dismissed || this.dismissed || this.selfDismissed; }
    // Destroy
    ngOnDestroy() { MessageComponent.instancesByElement.delete(this.elRef.nativeElement); }
}
MessageComponent.instancesByElement = new Map();
MessageComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessageComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
MessageComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.2", type: MessageComponent, selector: "egov-message", inputs: { message: "message", content: "content", html: "html", dismissable: "dismissable", type: "type", dismissed: "dismissed" }, host: { properties: { "class.info": "this.a", "class.warning": "this.b", "class.error": "this.c", "class.unavailable": "this.d", "class.dismissed": "this.e" } }, ngImport: i0, template: "<ng-template #messageTemplate let-message>\n    <button class=\"close\" *ngIf=\"message.dismissable\" (click)=\"dismiss()\" type=\"button\">\n        <mat-icon>close</mat-icon>\n    </button>\n    <div class=\"message-content\">\n        <div class=\"icon\">&nbsp;</div>\n        <ng-container *ngIf=\"message.content\">\n            <ng-container *ngIf=\"!message.html\">\n                <div class=\"message-text\">{{ message.content }}</div>\n            </ng-container>\n            <ng-container *ngIf=\"message.html\">\n                <div class=\"message-text\" [innerHTML]=\"message.content\"></div>\n            </ng-container>\n        </ng-container>\n        <ng-container *ngIf=\"!message.content\">\n            <div class=\"message-text\"><ng-content></ng-content></div>\n        </ng-container>\n    </div>\n</ng-template>\n<ng-container\n    *ngTemplateOutlet=\"\n        messageTemplate;\n        context: {\n            $implicit: message || {\n                dismissable: dismissable,\n                content: content,\n                html: html\n            }\n        }\n    \"\n></ng-container>\n", styles: [":host{display:block;margin-bottom:1.4em;border-radius:3px;background:#ffffff;border:2px solid #eeeeee;padding:.01em;z-index:1}:host.dismissed{display:none}:host button.close{float:right;cursor:pointer;padding:1em;position:relative;z-index:2}@media (hover: hover){:host button.close{visibility:hidden}}@media (hover: hover){:host:hover button.close{visibility:inherit}}:host .message-content{padding:1em 1em 1em 4.2em;position:relative;z-index:1}:host .message-content .icon{position:absolute;display:block;top:1em;left:0;width:4.2em;text-align:center}:host .message-content .icon:before{position:absolute;font-family:Material Icons;color:#ccc;line-height:1;font-size:160%;left:50%;margin-left:-.5em;top:50%;margin-top:-.5em}:host .message-content .message-text{display:inline}:host .message-content .message-text>::ng-deep p:last-child{margin-bottom:0}:host.info .message-content .icon:before{content:\"info\"}:host.warning .message-content .icon:before{content:\"warning\"}:host.error .message-content .icon:before{content:\"error\"}:host.unavailable .message-content .icon:before{content:\"block\"}:host.warning{border-color:#f0d744;background-color:#fefcf3}:host.warning .message-content .icon:before{color:#f0d744}:host.error,:host.unavailable{border-color:#d66;background-color:#fdf8f8}:host.error .message-content .icon:before,:host.unavailable .message-content .icon:before{color:#d66}\n"], components: [{ type: i1.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'egov-message', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-template #messageTemplate let-message>\n    <button class=\"close\" *ngIf=\"message.dismissable\" (click)=\"dismiss()\" type=\"button\">\n        <mat-icon>close</mat-icon>\n    </button>\n    <div class=\"message-content\">\n        <div class=\"icon\">&nbsp;</div>\n        <ng-container *ngIf=\"message.content\">\n            <ng-container *ngIf=\"!message.html\">\n                <div class=\"message-text\">{{ message.content }}</div>\n            </ng-container>\n            <ng-container *ngIf=\"message.html\">\n                <div class=\"message-text\" [innerHTML]=\"message.content\"></div>\n            </ng-container>\n        </ng-container>\n        <ng-container *ngIf=\"!message.content\">\n            <div class=\"message-text\"><ng-content></ng-content></div>\n        </ng-container>\n    </div>\n</ng-template>\n<ng-container\n    *ngTemplateOutlet=\"\n        messageTemplate;\n        context: {\n            $implicit: message || {\n                dismissable: dismissable,\n                content: content,\n                html: html\n            }\n        }\n    \"\n></ng-container>\n", styles: [":host{display:block;margin-bottom:1.4em;border-radius:3px;background:#ffffff;border:2px solid #eeeeee;padding:.01em;z-index:1}:host.dismissed{display:none}:host button.close{float:right;cursor:pointer;padding:1em;position:relative;z-index:2}@media (hover: hover){:host button.close{visibility:hidden}}@media (hover: hover){:host:hover button.close{visibility:inherit}}:host .message-content{padding:1em 1em 1em 4.2em;position:relative;z-index:1}:host .message-content .icon{position:absolute;display:block;top:1em;left:0;width:4.2em;text-align:center}:host .message-content .icon:before{position:absolute;font-family:Material Icons;color:#ccc;line-height:1;font-size:160%;left:50%;margin-left:-.5em;top:50%;margin-top:-.5em}:host .message-content .message-text{display:inline}:host .message-content .message-text>::ng-deep p:last-child{margin-bottom:0}:host.info .message-content .icon:before{content:\"info\"}:host.warning .message-content .icon:before{content:\"warning\"}:host.error .message-content .icon:before{content:\"error\"}:host.unavailable .message-content .icon:before{content:\"block\"}:host.warning{border-color:#f0d744;background-color:#fefcf3}:host.warning .message-content .icon:before{color:#f0d744}:host.error,:host.unavailable{border-color:#d66;background-color:#fdf8f8}:host.error .message-content .icon:before,:host.unavailable .message-content .icon:before{color:#d66}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { message: [{
                type: Input
            }], content: [{
                type: Input
            }], html: [{
                type: Input
            }], dismissable: [{
                type: Input
            }], type: [{
                type: Input
            }], dismissed: [{
                type: Input
            }], a: [{
                type: HostBinding,
                args: ['class.info']
            }], b: [{
                type: HostBinding,
                args: ['class.warning']
            }], c: [{
                type: HostBinding,
                args: ['class.error']
            }], d: [{
                type: HostBinding,
                args: ['class.unavailable']
            }], e: [{
                type: HostBinding,
                args: ['class.dismissed']
            }] } });

class MessagesComponent {
}
MessagesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessagesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
MessagesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.2", type: MessagesComponent, selector: "egov-messages", inputs: { messages: "messages" }, ngImport: i0, template: "<egov-message *ngFor=\"let message of messages\" [message]=\"message\"></egov-message>\n<ng-content></ng-content>\n", styles: [":host{display:block}\n"], components: [{ type: MessageComponent, selector: "egov-message", inputs: ["message", "content", "html", "dismissable", "type", "dismissed"] }], directives: [{ type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessagesComponent, decorators: [{
            type: Component,
            args: [{ selector: 'egov-messages', changeDetection: ChangeDetectionStrategy.OnPush, template: "<egov-message *ngFor=\"let message of messages\" [message]=\"message\"></egov-message>\n<ng-content></ng-content>\n", styles: [":host{display:block}\n"] }]
        }], propDecorators: { messages: [{
                type: Input
            }] } });

class MessagesModule {
}
MessagesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessagesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MessagesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessagesModule, declarations: [MessageComponent,
        MessagesComponent], imports: [CommonModule,
        MatIconModule], exports: [MessageComponent,
        MessagesComponent] });
MessagesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessagesModule, imports: [[
            CommonModule,
            MatIconModule,
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.2", ngImport: i0, type: MessagesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MessageComponent,
                        MessagesComponent,
                    ],
                    imports: [
                        CommonModule,
                        MatIconModule,
                    ],
                    exports: [
                        MessageComponent,
                        MessagesComponent,
                    ]
                }]
        }] });

/*
 * Public API Surface of angular-messages
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MessageComponent, MessagesComponent, MessagesModule };
//# sourceMappingURL=egovsolutions-angular-messages.mjs.map
